TYPE
//function type pre-definitions and type definiftions

//Alert Functions
    TNetAlertRaise=FUNCTION(AlertEventName:PWideChar;Buffer:Pointer;BufferSize:DWORD):NET_API_STATUS;stdcall;
    TNetAlertRaiseEx=FUNCTION(AlertEventName:PWideChar;VariableInfo:Pointer;VariableInfoSize:DWORD;ServiceName:PWideChar):NET_API_STATUS;stdcall;

//ApiBuffer Functions
    TNetApiBufferAllocate=FUNCTION(ByteCount:DWORD;varBuffer:Pointer):NET_API_STATUS;stdcall;
    TNetApiBufferFree=FUNCTION(Buffer:Pointer):NET_API_STATUS;stdcall;
    TNetApiBufferReallocate=FUNCTION(OldBuffer:Pointer;NewByteCount:DWORD;varNewBuffer:Pointer):NET_API_STATUS;stdcall;
    TNetApiBufferSize=FUNCTION(Buffer:Pointer;varByteCount:DWORD):NET_API_STATUS;stdcall;

{//Directory Service Functions (W2K+)
NetGetJoinableOUs
NetGetJoinInformation
NetJoinDomain
NetRenameMachineInDomain
NetUnjoinDomain
NetValidateName}

//Distributed File System (Dfs) Functions
    TNetDfsAdd=FUNCTION(DfsEntryPath, ServerName, ShareName, Comment:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsAddFtRoot=FUNCTION(ServerName, RootShare, FtDfsName, Comment:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsAddStdRoot=FUNCTION(ServerName, RootShare, Comment:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsAddStdRootForced=FUNCTION(ServerName, RootShare, Comment, Store:PWideChar):NET_API_STATUS;stdcall;
    TNetDfsEnum=FUNCTION(DfsName:PWideChar;Level:DWORD;PrefMaxLen:DWORD;Buffer:Pointer;varEntriesRead:DWORD;ResumeHandle:PDWORD):NET_API_STATUS;stdcall;
    TNetDfsGetClientInfo=FUNCTION(DfsEntryPath, ServerName, ShareName:PWideChar;Level:DWORD;Buffer:Pointer):NET_API_STATUS;stdcall;
    TNetDfsGetInfo=FUNCTION(DfsEntryPath, ServerName, ShareName:PWideChar;Level:DWORD;Buffer:Pointer):NET_API_STATUS;stdcall;
    TNetDfsManagerInitialize=FUNCTION(ServerName:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsRemove=FUNCTION(DfsEntryPath, ServerName, ShareName:PWideChar):NET_API_STATUS;stdcall;
    TNetDfsRemoveFtRoot=FUNCTION(ServerName, RootShare, FtDfsName:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsRemoveFtRootForced=FUNCTION(DomainName, ServerName, RootShare, FtDfsName:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsRemoveStdRoot=FUNCTION(ServerName:PWideChar;RootShare:PWideChar;Flags:DWORD):NET_API_STATUS;stdcall;
    TNetDfsSetClientInfo=FUNCTION(DfsEntryPath, ServerName, ShareName:PWideChar;Level:DWORD;Buffer:Pointer):NET_API_STATUS;stdcall;
    TNetDfsSetInfo=FUNCTION(DfsEntryPath, ServerName, ShareName:PWideChar;Level:DWORD;Buffer:Pointer):NET_API_STATUS;stdcall;

//Get Functions
    TNetGetAnyDCName=FUNCTION(servername:PWideChar;domainname:PWideChar;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetGetDCName=FUNCTION(servername:PWideChar;domainname:PWideChar;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetGetDisplayInformationIndex=FUNCTION(ServerName:PWideChar;Level:DWORD;Prefix:PWideChar;varIndex:DWORD):NET_API_STATUS;stdcall;
    TNetQueryDisplayInformation=FUNCTION(ServerName:PWideChar;Level:DWORD;Index:DWORD;EntriesRequested:DWORD;PreferredMaximumLength:DWORD;varReturnedEntryCount:DWORD;SortedBuffer:Pointer):NET_API_STATUS;stdcall;

//Group Functions
    TNetGroupAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetGroupAddUser=FUNCTION(servername:PWideChar;GroupName:PWideChar;username:PWideChar):NET_API_STATUS;stdcall;
    TNetGroupDel=FUNCTION(servername, groupname:PWideChar):NET_API_STATUS;stdcall;
    TNetGroupDelUser=FUNCTION(servername:PWideChar;GroupName:PWideChar;Username:PWideChar):NET_API_STATUS;stdcall;
    TNetGroupEnum=FUNCTION(servername:PWideChar;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetGroupGetInfo=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;varbufptr:Pointer):NET_API_STATUS;stdcall;
    TNetGroupGetUsers=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;ResumeHandle:PDWORD):NET_API_STATUS;stdcall;
    TNetGroupSetInfo=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetGroupSetUsers=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;totalentries:DWORD):NET_API_STATUS;stdcall;

{$IFDEF NT50}
    TNetJoinDomain=FUNCTION(lpServer, lpDomain, lpAccountOU, lpAccount, lpPassword:LPCWSTR;fJoinOptions:DWORD):NET_API_STATUS;stdcall;
    TNetUnjoinDomain=FUNCTION(lpServer, lpAccount, lpPassword:LPCWSTR;fUnjoinOptions:DWORD):NET_API_STATUS;stdcall;
    TNetRenameMachineInDomain=FUNCTION(lpServer, lpNewMachineName, lpAccount, lpPassword:LPCWSTR;fRenameOptions:DWORD):NET_API_STATUS;stdcall;
    TNetValidateName=FUNCTION(lpServer, lpName, lpAccount, lpPassword:LPCWSTR;NameType:TNetSetupNameType):NET_API_STATUS;stdcall;
    TNetGetJoinInformation=FUNCTION(lpServer:LPCWSTR;lpNameBuffer:LPWSTR;varBufferType:TNetSetupNameType):NET_API_STATUS;stdcall;
    TNetGetJoinableOUs=FUNCTION(lpServer, lpDomain, lpAccount, lpPassword:LPCWSTR;varOUCount:DWORD;OUs:Pointer):NET_API_STATUS;stdcall;
{$ENDIF}

//Local Group Functions
    TNetLocalGroupAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupAddMembers=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;totalentries:DWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupDel=FUNCTION(servername, groupname:PWideChar):NET_API_STATUS;stdcall;
    TNetLocalGroupDelMembers=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;totalentries:DWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupEnum=FUNCTION(servername:PWideChar;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupGetInfo=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;varbufptr:Pointer):NET_API_STATUS;stdcall;
    TNetLocalGroupGetMembers=FUNCTION(servername:PWideChar;localgroupname:PWideChar;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupSetInfo=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetLocalGroupSetMembers=FUNCTION(servername:PWideChar;groupname:PWideChar;level:DWORD;buf:Pointer;totalentries:DWORD):NET_API_STATUS;stdcall;

//Message Functions
    TNetMessageBufferSend=FUNCTION(servername:PWideChar;msgname:PWideChar;fromname:PWideChar;buf:Pointer;buflen:DWORD):NET_API_STATUS;stdcall;
    TNetMessageNameAdd=FUNCTION(servername, msgname:PWideChar):NET_API_STATUS;stdcall;
    TNetMessageNameDel=FUNCTION(servername, msgname:PWideChar):NET_API_STATUS;stdcall;
    TNetMessageNameEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetMessageNameGetInfo=FUNCTION(servername:PWideChar;msgname:PWideChar;level:DWORD;varbufptr:Pointer):NET_API_STATUS;stdcall;

//NetFile Functions
    TNetFileClose=FUNCTION(servername:LPTSTR;fileid:DWORD):NET_API_STATUS;stdcall;
    TNetFileEnum=FUNCTION(servername:LPTSTR;basepath:LPTSTR;username:LPTSTR;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetFileGetInfo=FUNCTION(servername:LPTSTR;fileid:DWORD;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;

//Remote Utility Functions
    TNetRemoteTOD=FUNCTION(UncServerName:PWideChar;BufferPtr:Pointer):NET_API_STATUS;stdcall;
    TNetRemoteComputerSupports=FUNCTION(UncServerName:PWideChar;OptionsWanted:DWORD;varOptionsSupported:DWORD):NET_API_STATUS;stdcall;

//Replicator Functions
    TNetReplExportDirAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetReplExportDirDel=FUNCTION(servername, dirname:PWideChar):NET_API_STATUS;stdcall;
    TNetReplExportDirEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;
    TNetReplExportDirGetInfo=FUNCTION(servername:PWideChar;dirname:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetReplExportDirLock=FUNCTION(servername, dirname:PWideChar):NET_API_STATUS;stdcall;
    TNetReplExportDirSetInfo=FUNCTION(servername:PWideChar;dirname:PWideChar;level:DWORD;constbuf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetReplExportDirUnlock=FUNCTION(servername:PWideChar;dirname:PWideChar;unlockforce:DWORD):NET_API_STATUS;stdcall;
    TNetReplGetInfo=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetReplImportDirAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetReplImportDirDel=FUNCTION(servername, dirname:PWideChar):NET_API_STATUS;stdcall;
    TNetReplImportDirEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;
    TNetReplImportDirGetInfo=FUNCTION(servername, dirname:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetReplImportDirLock=FUNCTION(servername, dirname:PWideChar):NET_API_STATUS;stdcall;
    TNetReplImportDirUnlock=FUNCTION(servername:PWideChar;dirname:PWideChar;unlockforce:DWORD):NET_API_STATUS;stdcall;
    TNetReplSetInfo=FUNCTION(servername:PWideChar;level:DWORD;constbuf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;

//Schedule Functions
    TNetScheduleJobAdd=FUNCTION(Servername:PWideChar;Buffer:Pointer;varJobId:DWORD):NET_API_STATUS;stdcall;
    TNetScheduleJobDel=FUNCTION(Servername:PWideChar;MinJobId:DWORD;MaxJobId:DWORD):NET_API_STATUS;stdcall;
    TNetScheduleJobEnum=FUNCTION(Servername:PWideChar;PointerToBuffer:Pointer;PrefferedMaximumLength:DWORD;varEntriesRead:DWORD;varTotalEntries:DWORD;ResumeHandle:PDWORD):NET_API_STATUS;stdcall;
    TNetScheduleJobGetInfo=FUNCTION(Servername:PWideChar;JobId:DWORD;PointerToBuffer:Pointer):NET_API_STATUS;stdcall;

//Server Functions
    TNetServerDiskEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetServerEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;servertype:DWORD;domain:PWideChar;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetServerGetInfo=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetServerSetInfo=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;ParmError:PDWORD):NET_API_STATUS;stdcall;

//Server and Workstation Transport Functions
    TNetServerComputerNameAdd=FUNCTION(ServerName:PWideChar;EmulatedDomainName:PWideChar;EmulatedServerName:PWideChar):NET_API_STATUS;stdcall;
    TNetServerComputerNameDel=FUNCTION(ServerName, EmulatedServerName:PWideChar):NET_API_STATUS;stdcall;
    TNetServerTransportAdd=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetServerTransportAddEx=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetServerTransportDel=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetServerTransportEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;
    TNetWkstaTransportAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetWkstaTransportDel=FUNCTION(servername:PWideChar;transportname:PWideChar;ucond:DWORD):NET_API_STATUS;stdcall;
    TNetWkstaTransportEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;

//Session Functions
    TNetSessionDel=FUNCTION(servername:LPTSTR;UncClientName:LPTSTR;username:LPTSTR):NET_API_STATUS;stdcall;
    TNetSessionEnum=FUNCTION(servername:LPTSTR;UncClientName:LPTSTR;username:LPTSTR;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetSessionGetInfo=FUNCTION(servername:LPTSTR;UncClientName:LPTSTR;username:LPTSTR;level:DWORD;varbufptr:Pointer):NET_API_STATUS;stdcall;

//Share Functions
    TNetConnectionEnum=FUNCTION(servername:LPTSTR;qualifier:LPTSTR;level:DWORD;varbufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetShareAdd=FUNCTION(servername:LPTSTR;level:DWORD;constbuf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetShareCheck=FUNCTION(servername:LPTSTR;device:LPTSTR;var_type:DWORD):NET_API_STATUS;stdcall;
    TNetShareDel=FUNCTION(servername:LPTSTR;netname:LPTSTR;reserved:DWORD):NET_API_STATUS;stdcall;
    TNetShareEnum=FUNCTION(servername:LPTSTR;level:DWORD;varbutptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetShareGetInfo=FUNCTION(servername:LPTSTR;netname:LPTSTR;level:DWORD;varbutptr:Pointer):NET_API_STATUS;stdcall;
    TNetShareSetInfo=FUNCTION(servername:LPTSTR;netname:LPTSTR;leve:DWORD;constbuf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;

//Statistics Function
    TNetStatisticsGet=FUNCTION(server:PWideChar;service:PWideChar;level:DWORD;options:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;

//Use Functions
    TNetUseAdd=FUNCTION(UncServerName:PWideChar;Level:DWORD;Buf:Pointer;ParmError:PDWORD):NET_API_STATUS;stdcall;
    TNetUseDel=FUNCTION(UncServerName, UseName:PWideChar;ForceCond:DWORD):NET_API_STATUS;stdcall;
    TNetUseEnum=FUNCTION(UncServerName:PWideChar;Level:DWORD;BufPtr:Pointer;PreferedMaximumSize:DWORD;varEntriesRead:DWORD;varTotalEntries:DWORD;ResumeHandle:PDWORD):NET_API_STATUS;stdcall;
    TNetUseGetInfo=FUNCTION(UncServerName:PWideChar;UseName:PWideChar;Level:DWORD;BufPtr:Pointer):NET_API_STATUS;stdcall;

//User Functions
    TNetUserAdd=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetUserChangePassword=FUNCTION(domainname, username, oldpassword, newpassword:PWideChar):NET_API_STATUS;stdcall;
    TNetUserDel=FUNCTION(servername:PWideChar;username:PWideChar):NET_API_STATUS;stdcall;
    TNetUserEnum=FUNCTION(servername:PWideChar;level, filter:DWORD;VAR bufptr:Pointer;prefmaxlen:DWORD;VAR entriesread:DWORD;VAR totalentries:DWORD;resume_handle:PDWORD):NET_API_STATUS;stdcall;
    TNetUserGetGroups=FUNCTION(servername:PWideChar;username:PWideChar;level:DWORD;VAR bufptr:Pointer;prefmaxlen:DWORD;VAR entriesread:DWORD;VAR totalentries:DWORD):NET_API_STATUS;stdcall;
    TNetUserGetInfo=FUNCTION(servername:PWideChar;username:PWideChar;level:DWORD;VAR bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetUserGetLocalGroups=FUNCTION(servername:PWideChar;username:PWideChar;level:DWORD;flags:DWORD;VAR bufptr:Pointer;prefmaxlen:DWORD;VAR entriesread:DWORD;VAR totalentries:DWORD):NET_API_STATUS;stdcall;
    TNetUserSetGroups=FUNCTION(servername:PWideChar;username:PWideChar;level:DWORD;buf:Pointer;num_entries:DWORD):NET_API_STATUS;stdcall;
    TNetUserSetInfo=FUNCTION(servername:PWideChar;username:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;

//User Modals Functions
    TNetUserModalsGet=FUNCTION(servername:PWideChar;level:DWORD;varbufptr:Pointer):NET_API_STATUS;stdcall;
    TNetUserModalsSet=FUNCTION(servername:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;

//Workstation and Workstation User Functions
    TNetWkstaGetInfo=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetWkstaSetInfo=FUNCTION(servername:PWideChar;level:DWORD;buffer:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetWkstaUserGetInfo=FUNCTION(reserved:PWideChar;level:DWORD;bufptr:Pointer):NET_API_STATUS;stdcall;
    TNetWkstaUserSetInfo=FUNCTION(reserved:PWideChar;level:DWORD;buf:Pointer;parm_err:PDWORD):NET_API_STATUS;stdcall;
    TNetWkstaUserEnum=FUNCTION(servername:PWideChar;level:DWORD;bufptr:Pointer;prefmaxlen:DWORD;varentriesread:DWORD;vartotalentries:DWORD;resumehandle:PDWORD):NET_API_STATUS;stdcall;


